; Assembler Directives
.586
    .model  flat, stdcall
    option  casemap:none

    ; Include Files
    include	\masm32\include\windows.inc
    include \masm32\macros\macros.asm

    uselib user32,kernel32,gdi32,msvcrt,shell32,ole32

Unknown STRUCT
   QueryInterface         DD	0
   AddRef               DD	0
   Release               DD	0
Unknown ENDS

IShellLink STRUCT
   IUnknown            Unknown      <>

   GetPath               DD	0
   GetIDList             DD	0
   SetIDList            DD	0
   GetDescription         DD	0
   SetDescription         DD	0
   GetWorkingDirectory      DD	0
   SetWorkingDirectory      DD	0
   GetArguments         DD	0
   SetArguments         DD	0
   GetHotkey            DD	0
   SetHotkey            DD	0
   GetShowCmd            DD	0
   SetShowCmd            DD	0
   GetIconLocation         DD	0
   SetIconLocation         DD	0
   SetRelativePath         DD	0
   Resolve               DD	0
   SetPath               DD	0
IShellLink ENDS

IPersistFile STRUCT
   IUnknown      Unknown      <>

   GetClassID      DD	0
   IsDirty         DD	0
   Load         DD	0
   Save         DD	0
   SaveCompleted   DD	0
   GetCurFile      DD	0
IPersistFile ENDS

; --------------- Data Section
.data

	CL_IID_IShellLink	GUID <0000214eeh, 00000h, 00000h, <0c0h, 000h, 000h, 000h, 000h, 000h, 000h, 046h>>
	CL_CLSID_ShellLink	GUID <000021401h, 00000h, 00000h, <0c0h, 000h, 000h, 000h, 000h, 000h, 000h, 046h>>
	CL_IID_IPersistFile	GUID <00000010bH, 00000H, 00000H, <0C0H, 000H, 000H, 000H, 000H, 000H, 000H, 046H>>

    CommandLine		dd	0
    hInstance		dd	0

.code

; --------------- Procedures Declarations
MainInit		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
CreateLink		PROTO	:DWORD,:DWORD,:DWORD

; --------------- Program start
start:

    invoke GetModuleHandle,NULL
    mov hInstance, eax
    invoke GetCommandLine
    mov CommandLine, eax
    invoke MainInit,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
    invoke ExitProcess,eax

; --------------- Program main inits
MainInit 		PROC	USES esi edi hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

	invoke CoInitialize, 0

      invoke CreateLink, chr$("C:\WINDOWS\notepad.exe"), chr$("c:\notepad.LNK"), chr$("NOTEPAD")

	ret

MainInit 		ENDP

CreateLink PROC	USES esi edi	lpLinkTarget:DWORD,lpOutputFile:DWORD,lpDescription:DWORD

	LOCAL	psl:DWORD
	LOCAL	ppf:DWORD
	LOCAL	pwsz:DWORD

	invoke GlobalAlloc,40h,540
	mov [pwsz],eax

	invoke CoCreateInstance, addr CL_CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,ADDR CL_IID_IShellLink,addr psl
	cmp eax,S_OK
	je @F
		push eax
		jmp O1
	@@:

	lea eax,ppf
	push eax
	lea eax,CL_IID_IPersistFile
	push eax
	push [psl]
	mov edi,[psl]
	mov edi,[edi]
	add edi,IShellLink.IUnknown.QueryInterface
	mov eax, [edi]
	call eax
	cmp eax,S_OK
	je @F
		push eax
		jmp P1
	@@:

	push [lpLinkTarget]
	push [psl]
	mov edi,[psl]
	mov edi,[edi]
	add edi,IShellLink.SetPath
	mov eax, [edi]
	call eax
	cmp eax,S_OK
	je @F
		push eax
		jmp A1
	@@:

	push 0
	push [lpLinkTarget]
	push [psl]
	mov edi,[psl]
	mov edi,[edi]
	add edi,IShellLink.SetIconLocation
	mov eax, [edi]
	call eax
	cmp eax,S_OK
	je @F
		push eax
		jmp A1
	@@:
	
	cmp lpDescription,NULL
	je @F
	push [lpDescription]
	push [psl]
	mov edi,[psl]
	mov edi,[edi]
	add edi,IShellLink.SetDescription
	mov eax, [edi]
	call eax
	cmp eax,S_OK
	je @F
		push eax
		jmp A1
	@@:

	invoke MultiByteToWideChar,CP_ACP,NULL,[lpOutputFile],-1,[pwsz],MAX_PATH

	push TRUE
	push [pwsz]
	push [ppf]
	mov edi,[ppf]
	mov edi,[edi]
	add edi,IPersistFile.Save
	mov eax, [edi]
	call eax
	cmp eax,S_OK
	je @F
		push eax
		jmp A1
	@@:
	push S_OK

	A1: ;AllDone
	push [ppf]
	mov edi,[ppf]
	mov edi,[edi]
	add edi,IPersistFile.IUnknown.Release
	mov eax, [edi]
	call eax
	
	P1: ;NoPersist
	push [psl]
	mov edi,[psl]
	mov edi,[edi]
	add edi,IShellLink.IUnknown.Release
	mov eax, [edi]
	call eax

   O1: ;OleBad
   invoke GlobalFree,[pwsz]
   pop eax

   ret

CreateLink ENDP

; --------------- Program end
end start